package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import java.util.function.Function;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.phys.Vec3;

public class RetreatingAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.RetreatingAffix> CODEC;
  
  protected LootRarity minRarity;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.CODEC.fieldOf("min_rarity").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.RetreatingAffix::new));
  }
  
  public RetreatingAffix(LootRarity minRarity) {
    super(AffixType.ABILITY);
    this.minRarity = minRarity;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat == LootCategory.SHIELD && rarity.isAtLeast(this.minRarity));
  }
  
  public float onShieldBlock(ItemStack stack, LootRarity rarity, float level, LivingEntity entity, DamageSource source, float amount) {
    Entity tSource = source.m_7639_();
    if (tSource != null && tSource.m_20280_((Entity)entity) <= 9.0D) {
      Vec3 look = entity.m_20154_();
      entity.m_20256_(new Vec3(1.0D * -look.f_82479_, 0.25D, 1.0D * -look.f_82481_));
      entity.f_19864_ = true;
      entity.m_6853_(false);
    } 
    return super.onShieldBlock(stack, rarity, level, entity, source, amount);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
